Index: drivers/filesystems/btrfs/btrfs.c
===================================================================
--- drivers/filesystems/btrfs/btrfs.c	(révision 75772)
+++ drivers/filesystems/btrfs/btrfs.c	(copie de travail)
@@ -3988,35 +4304,72 @@
             goto exit;
         }
     }
-    
-    commit_batch_list(Vcb, &batchlist, Irp, NULL);
-    
-    Vcb->volume_fcb = create_fcb(NonPagedPool);
+
+    Status = commit_batch_list(Vcb, &batchlist, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("commit_batch_list returned %08x\n", Status);
+        goto exit;
+    }
+
+    Vcb->volume_fcb = create_fcb(Vcb, NonPagedPool);
     if (!Vcb->volume_fcb) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto exit;
     }
-    
+
     Vcb->volume_fcb->Vcb = Vcb;
     Vcb->volume_fcb->sd = NULL;
-    
-    root_fcb = create_fcb(NonPagedPool);
+
+    Vcb->dummy_fcb = create_fcb(Vcb, NonPagedPool);
+    if (!Vcb->dummy_fcb) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+
+    Vcb->dummy_fcb->Vcb = Vcb;
+    Vcb->dummy_fcb->type = BTRFS_TYPE_DIRECTORY;
+    Vcb->dummy_fcb->inode = 2;
+    Vcb->dummy_fcb->subvol = Vcb->root_root;
+    Vcb->dummy_fcb->atts = FILE_ATTRIBUTE_DIRECTORY;
+    Vcb->dummy_fcb->inode_item.st_nlink = 1;
+    Vcb->dummy_fcb->inode_item.st_mode = __S_IFDIR;
+
+    Vcb->dummy_fcb->hash_ptrs = ExAllocatePoolWithTag(PagedPool, sizeof(LIST_ENTRY*) * 256, ALLOC_TAG);
+    if (!Vcb->dummy_fcb->hash_ptrs) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+
+    RtlZeroMemory(Vcb->dummy_fcb->hash_ptrs, sizeof(LIST_ENTRY*) * 256);
+
+    Vcb->dummy_fcb->hash_ptrs_uc = ExAllocatePoolWithTag(PagedPool, sizeof(LIST_ENTRY*) * 256, ALLOC_TAG);
+    if (!Vcb->dummy_fcb->hash_ptrs_uc) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto exit;
+    }
+
+    RtlZeroMemory(Vcb->dummy_fcb->hash_ptrs_uc, sizeof(LIST_ENTRY*) * 256);
+
+    root_fcb = create_fcb(Vcb, NonPagedPool);
     if (!root_fcb) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto exit;
     }
-    
+
     root_fcb->Vcb = Vcb;
     root_fcb->inode = SUBVOL_ROOT_INODE;
     root_fcb->type = BTRFS_TYPE_DIRECTORY;
-    
+
 #ifdef DEBUG_FCB_REFCOUNTS
     WARN("volume FCB = %p\n", Vcb->volume_fcb);
     WARN("root FCB = %p\n", root_fcb);
 #endif
-    
+
     root_fcb->subvol = find_default_subvol(Vcb, Irp);
 
     if (!root_fcb->subvol) {
@@ -4024,49 +4377,49 @@
         Status = STATUS_INTERNAL_ERROR;
         goto exit;
     }
-    
-    Status = load_dir_children(root_fcb, TRUE, Irp);
+
+    Status = load_dir_children(Vcb, root_fcb, TRUE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("load_dir_children returned %08x\n", Status);
         goto exit;
     }
-    
+
     searchkey.obj_id = root_fcb->inode;
     searchkey.obj_type = TYPE_INODE_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, root_fcb->subvol, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
         goto exit;
     }
-    
+
     if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
         ERR("couldn't find INODE_ITEM for root directory\n");
         Status = STATUS_INTERNAL_ERROR;
         goto exit;
     }
-    
+
     if (tp.item->size > 0)
         RtlCopyMemory(&root_fcb->inode_item, tp.item->data, min(sizeof(INODE_ITEM), tp.item->size));
-    
+
     fcb_get_sd(root_fcb, NULL, TRUE, Irp);
-    
-    root_fcb->atts = get_file_attributes(Vcb, &root_fcb->inode_item, root_fcb->subvol, root_fcb->inode, root_fcb->type, FALSE, FALSE, Irp);
-    
-    Vcb->root_fileref = create_fileref();
+
+    root_fcb->atts = get_file_attributes(Vcb, root_fcb->subvol, root_fcb->inode, root_fcb->type, FALSE, FALSE, Irp);
+
+    Vcb->root_fileref = create_fileref(Vcb);
     if (!Vcb->root_fileref) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto exit;
     }
-    
+
     Vcb->root_fileref->fcb = root_fcb;
     InsertTailList(&root_fcb->subvol->fcbs, &root_fcb->list_entry);
     InsertTailList(&Vcb->all_fcbs, &root_fcb->list_entry_all);
-    
+
     root_fcb->fileref = Vcb->root_fileref;
-    
+
     root_ccb = ExAllocatePoolWithTag(PagedPool, sizeof(ccb), ALLOC_TAG);
     if (!root_ccb) {
         ERR("out of memory\n");
@@ -4073,18 +4426,18 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto exit;
     }
-    
+
     Vcb->root_file = IoCreateStreamFileObject(NULL, DeviceToMount);
     Vcb->root_file->FsContext = root_fcb;
     Vcb->root_file->SectionObjectPointer = &root_fcb->nonpaged->segment_object;
     Vcb->root_file->Vpb = DeviceObject->Vpb;
-    
+
     RtlZeroMemory(root_ccb, sizeof(ccb));
     root_ccb->NodeType = BTRFS_NODE_TYPE_CCB;
     root_ccb->NodeSize = sizeof(ccb);
-    
+
     Vcb->root_file->FsContext2 = root_ccb;
-    
+
     _SEH2_TRY {
         CcInitializeCacheMap(Vcb->root_file, (PCC_FILE_SIZES)(&root_fcb->Header.AllocationSize), FALSE, cache_callbacks, Vcb->root_file);
     } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
@@ -4091,20 +4444,20 @@
         Status = _SEH2_GetExceptionCode();
         goto exit;
     } _SEH2_END;
-    
+
     le = Vcb->devices.Flink;
     while (le != &Vcb->devices) {
         device* dev2 = CONTAINING_RECORD(le, device, list_entry);
-        
+
         Status = find_disk_holes(Vcb, dev2, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("find_disk_holes returned %08x\n", Status);
             goto exit;
         }
-        
+
         le = le->Flink;
     }
-    
+
     NewDeviceObject->Vpb = IrpSp->Parameters.MountVolume.Vpb;
     IrpSp->Parameters.MountVolume.Vpb->DeviceObject = NewDeviceObject;
     IrpSp->Parameters.MountVolume.Vpb->Flags |= VPB_MOUNTED;
@@ -4112,34 +4465,43 @@
     NewDeviceObject->Vpb->VolumeLabel[0] = '?';
     NewDeviceObject->Vpb->VolumeLabel[1] = 0;
     NewDeviceObject->Vpb->ReferenceCount++; // FIXME - should we deref this at any point?
-    Vcb->Vpb = NewDeviceObject->Vpb;
-    
+
     KeInitializeEvent(&Vcb->flush_thread_finished, NotificationEvent, FALSE);
-    
+
     Status = PsCreateSystemThread(&Vcb->flush_thread_handle, 0, NULL, NULL, NULL, flush_thread, NewDeviceObject);
     if (!NT_SUCCESS(Status)) {
         ERR("PsCreateSystemThread returned %08x\n", Status);
         goto exit;
     }
-    
+
     Status = create_calc_threads(NewDeviceObject);
     if (!NT_SUCCESS(Status)) {
         ERR("create_calc_threads returned %08x\n", Status);
         goto exit;
     }
-    
+
     Status = registry_mark_volume_mounted(&Vcb->superblock.uuid);
     if (!NT_SUCCESS(Status))
         WARN("registry_mark_volume_mounted returned %08x\n", Status);
-    
+
     Status = look_for_balance_item(Vcb);
     if (!NT_SUCCESS(Status) && Status != STATUS_NOT_FOUND)
         WARN("look_for_balance_item returned %08x\n", Status);
-    
+
     Status = STATUS_SUCCESS;
 
+    if (vde)
+        vde->mounted_device = NewDeviceObject;
+
+    ExInitializeResourceLite(&Vcb->send_load_lock);
+
 exit:
+    if (pdode)
+        ExReleaseResourceLite(&pdode->child_lock);
+
+exit2:
     if (Vcb) {
+        ExReleaseResourceLite(&Vcb->tree_lock);
         ExReleaseResourceLite(&Vcb->load_lock);
     }
 
@@ -4148,32 +4510,47 @@
             if (init_lookaside) {
                 ExDeletePagedLookasideList(&Vcb->tree_data_lookaside);
                 ExDeletePagedLookasideList(&Vcb->traverse_ptr_lookaside);
-                ExDeletePagedLookasideList(&Vcb->rollback_item_lookaside);
                 ExDeletePagedLookasideList(&Vcb->batch_item_lookaside);
+                ExDeletePagedLookasideList(&Vcb->fileref_lookaside);
+                ExDeletePagedLookasideList(&Vcb->fcb_lookaside);
+                ExDeletePagedLookasideList(&Vcb->name_bit_lookaside);
                 ExDeleteNPagedLookasideList(&Vcb->range_lock_lookaside);
+                ExDeleteNPagedLookasideList(&Vcb->fileref_np_lookaside);
+                ExDeleteNPagedLookasideList(&Vcb->fcb_np_lookaside);
             }
-                
+
             if (Vcb->root_file)
                 ObDereferenceObject(Vcb->root_file);
-            else if (Vcb->root_fileref)
-                free_fileref(Vcb->root_fileref);
-            else if (root_fcb)
-                free_fcb(root_fcb);
+            else if (Vcb->root_fileref) {
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, Vcb->root_fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+            } else if (root_fcb) {
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fcb(Vcb, root_fcb);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+            }
 
-            if (Vcb->volume_fcb)
-                free_fcb(Vcb->volume_fcb);
+            if (Vcb->volume_fcb) {
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fcb(Vcb, Vcb->volume_fcb);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+            }
 
             ExDeleteResourceLite(&Vcb->tree_lock);
             ExDeleteResourceLite(&Vcb->load_lock);
             ExDeleteResourceLite(&Vcb->fcb_lock);
             ExDeleteResourceLite(&Vcb->chunk_lock);
+            ExDeleteResourceLite(&Vcb->dirty_fcbs_lock);
+            ExDeleteResourceLite(&Vcb->dirty_filerefs_lock);
+            ExDeleteResourceLite(&Vcb->dirty_subvols_lock);
+            ExDeleteResourceLite(&Vcb->scrub.stats_lock);
 
             if (Vcb->devices.Flink) {
                 while (!IsListEmpty(&Vcb->devices)) {
-                    LIST_ENTRY* le = RemoveHeadList(&Vcb->devices);
-                    device* dev = CONTAINING_RECORD(le, device, list_entry);
-                    
-                    ExFreePool(dev);
+                    device* dev2 = CONTAINING_RECORD(RemoveHeadList(&Vcb->devices), device, list_entry);
+
+                    ExFreePool(dev2);
                 }
             }
         }
@@ -4184,7 +4561,7 @@
         ExAcquireResourceExclusiveLite(&global_loading_lock, TRUE);
         InsertTailList(&VcbList, &Vcb->list_entry);
         ExReleaseResourceLite(&global_loading_lock);
-        
+
         FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_MOUNT);
     }
 
@@ -4193,178 +4570,246 @@
     return Status;
 }
 
-static NTSTATUS verify_volume(PDEVICE_OBJECT devobj) {
-    device_extension* Vcb = devobj->DeviceExtension;
-    ULONG cc, to_read;
-    IO_STATUS_BLOCK iosb;
+static NTSTATUS verify_device(_In_ device_extension* Vcb, _Inout_ device* dev) {
     NTSTATUS Status;
     superblock* sb;
     UINT32 crc32;
-    LIST_ENTRY* le;
-    
-    if (Vcb->removing)
+    ULONG to_read, cc;
+
+    if (!dev->devobj)
         return STATUS_WRONG_VOLUME;
-    
-    Status = dev_ioctl(Vcb->Vpb->RealDevice, IOCTL_STORAGE_CHECK_VERIFY, NULL, 0, &cc, sizeof(ULONG), TRUE, &iosb);
-    
-    if (!NT_SUCCESS(Status)) {
-        ERR("dev_ioctl returned %08x\n", Status);
-        return Status;
+
+    if (dev->removable) {
+        IO_STATUS_BLOCK iosb;
+
+        Status = dev_ioctl(dev->devobj, IOCTL_STORAGE_CHECK_VERIFY, NULL, 0, &cc, sizeof(ULONG), TRUE, &iosb);
+
+        if (IoIsErrorUserInduced(Status)) {
+            ERR("IOCTL_STORAGE_CHECK_VERIFY returned %08x (user-induced)\n", Status);
+
+            if (Vcb->vde) {
+                pdo_device_extension* pdode = Vcb->vde->pdode;
+                LIST_ENTRY* le2;
+                BOOL changed = FALSE;
+
+                ExAcquireResourceExclusiveLite(&pdode->child_lock, TRUE);
+
+                le2 = pdode->children.Flink;
+                while (le2 != &pdode->children) {
+                    volume_child* vc = CONTAINING_RECORD(le2, volume_child, list_entry);
+
+                    if (vc->devobj == dev->devobj) {
+                        TRACE("removing device\n");
+
+                        remove_volume_child(Vcb->vde, vc, TRUE);
+                        changed = TRUE;
+
+                        break;
+                    }
+
+                    le2 = le2->Flink;
+                }
+
+                if (!changed)
+                    ExReleaseResourceLite(&pdode->child_lock);
+            }
+        } else if (!NT_SUCCESS(Status)) {
+            ERR("IOCTL_STORAGE_CHECK_VERIFY returned %08x\n", Status);
+            return Status;
+        } else if (iosb.Information < sizeof(ULONG)) {
+            ERR("iosb.Information was too short\n");
+            return STATUS_INTERNAL_ERROR;
+        }
+
+        dev->change_count = cc;
     }
-    
-    to_read = devobj->SectorSize == 0 ? sizeof(superblock) : sector_align(sizeof(superblock), devobj->SectorSize);
-    
+
+    to_read = dev->devobj->SectorSize == 0 ? sizeof(superblock) : (ULONG)sector_align(sizeof(superblock), dev->devobj->SectorSize);
+
     sb = ExAllocatePoolWithTag(NonPagedPool, to_read, ALLOC_TAG);
     if (!sb) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
-    Status = sync_read_phys(Vcb->Vpb->RealDevice, superblock_addrs[0], to_read, (PUCHAR)sb, TRUE);
+
+    Status = sync_read_phys(dev->devobj, superblock_addrs[0], to_read, (PUCHAR)sb, TRUE);
     if (!NT_SUCCESS(Status)) {
         ERR("Failed to read superblock: %08x\n", Status);
         ExFreePool(sb);
         return Status;
     }
-    
+
     if (sb->magic != BTRFS_MAGIC) {
         ERR("not a BTRFS volume\n");
         ExFreePool(sb);
         return STATUS_WRONG_VOLUME;
     }
-    
-    if (RtlCompareMemory(&sb->uuid, &Vcb->superblock.uuid, sizeof(BTRFS_UUID)) != sizeof(BTRFS_UUID)) {
-        ERR("different UUIDs\n");
+
+    crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
+    TRACE("crc32 was %08x, expected %08x\n", crc32, *((UINT32*)sb->checksum));
+
+    if (crc32 != *((UINT32*)sb->checksum)) {
+        ERR("checksum error\n");
         ExFreePool(sb);
         return STATUS_WRONG_VOLUME;
     }
-    
-    crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
-    TRACE("crc32 was %08x, expected %08x\n", crc32, *((UINT32*)sb->checksum));
-    
-    if (crc32 != *((UINT32*)sb->checksum)) {
+
+    if (RtlCompareMemory(&sb->uuid, &Vcb->superblock.uuid, sizeof(BTRFS_UUID)) != sizeof(BTRFS_UUID)) {
         ERR("different UUIDs\n");
         ExFreePool(sb);
         return STATUS_WRONG_VOLUME;
     }
-    
+
     ExFreePool(sb);
-    
-    ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-    
+
+    dev->devobj->Flags &= ~DO_VERIFY_VOLUME;
+
+    return STATUS_SUCCESS;
+}
+
+static NTSTATUS verify_volume(_In_ PDEVICE_OBJECT devobj) {
+    device_extension* Vcb = devobj->DeviceExtension;
+    NTSTATUS Status;
+    LIST_ENTRY* le;
+    UINT64 failed_devices = 0;
+    BOOL locked = FALSE, remove = FALSE;
+
+    if (!(Vcb->Vpb->Flags & VPB_MOUNTED))
+        return STATUS_WRONG_VOLUME;
+
+    if (!ExIsResourceAcquiredExclusive(&Vcb->tree_lock)) {
+        ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
+        locked = TRUE;
+    }
+
+    if (Vcb->removing) {
+        if (locked) ExReleaseResourceLite(&Vcb->tree_lock);
+        return STATUS_WRONG_VOLUME;
+    }
+
+    InterlockedIncrement(&Vcb->open_files); // so pnp_surprise_removal doesn't uninit the device while we're still using it
+
     le = Vcb->devices.Flink;
     while (le != &Vcb->devices) {
         device* dev = CONTAINING_RECORD(le, device, list_entry);
-        
-        if (dev->removable) {
-            NTSTATUS Status;
-            ULONG cc;
-            IO_STATUS_BLOCK iosb;
-            
-            Status = dev_ioctl(dev->devobj, IOCTL_STORAGE_CHECK_VERIFY, NULL, 0, &cc, sizeof(ULONG), TRUE, &iosb);
-            
-            if (!NT_SUCCESS(Status)) {
-                ExReleaseResourceLite(&Vcb->tree_lock);
-                ERR("dev_ioctl returned %08x\n", Status);
-                return Status;
-            }
-            
-            if (iosb.Information < sizeof(ULONG)) {
-                ExReleaseResourceLite(&Vcb->tree_lock);
-                ERR("iosb.Information was too short\n");
-                return STATUS_INTERNAL_ERROR;
-            }
-            
-            dev->change_count = cc;
+
+        Status = verify_device(Vcb, dev);
+        if (!NT_SUCCESS(Status)) {
+            failed_devices++;
+
+            if (dev->devobj && Vcb->options.allow_degraded)
+                dev->devobj = NULL;
         }
-        
-        dev->devobj->Flags &= ~DO_VERIFY_VOLUME;
-        
+
         le = le->Flink;
     }
-    
-    ExReleaseResourceLite(&Vcb->tree_lock);
-    
-    Vcb->Vpb->RealDevice->Flags &= ~DO_VERIFY_VOLUME;
-    
-    return STATUS_SUCCESS;
+
+    InterlockedDecrement(&Vcb->open_files);
+
+    if (Vcb->removing && Vcb->open_files == 0)
+        remove = TRUE;
+
+    if (locked)
+        ExReleaseResourceLite(&Vcb->tree_lock);
+
+    if (remove) {
+        uninit(Vcb, FALSE);
+        return Status;
+    }
+
+    if (failed_devices == 0 || (Vcb->options.allow_degraded && failed_devices < Vcb->superblock.num_devices)) {
+        Vcb->Vpb->RealDevice->Flags &= ~DO_VERIFY_VOLUME;
+
+        return STATUS_SUCCESS;
+    }
+
+    return Status;
 }
 
-static NTSTATUS STDCALL drv_file_system_control(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+_Dispatch_type_(IRP_MJ_FILE_SYSTEM_CONTROL)
+_Function_class_(DRIVER_DISPATCH)
+static NTSTATUS drv_file_system_control(_In_ PDEVICE_OBJECT DeviceObject, _In_ PIRP Irp) {
     PIO_STACK_LOCATION IrpSp;
     NTSTATUS Status;
     device_extension* Vcb = DeviceObject->DeviceExtension;
     BOOL top_level;
 
-    TRACE("file system control\n");
-    
     FsRtlEnterFileSystem();
 
+    TRACE("file system control\n");
+
     top_level = is_top_level(Irp);
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_file_system_control(DeviceObject, Irp);
+        goto end;
+    } else if (!Vcb || (Vcb->type != VCB_TYPE_FS && Vcb->type != VCB_TYPE_CONTROL)) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
-    
+
     Status = STATUS_NOT_IMPLEMENTED;
 
     IrpSp = IoGetCurrentIrpStackLocation( Irp );
-    
+
     Irp->IoStatus.Information = 0;
-    
+
     switch (IrpSp->MinorFunction) {
         case IRP_MN_MOUNT_VOLUME:
             TRACE("IRP_MN_MOUNT_VOLUME\n");
-            
+
             Status = mount_vol(DeviceObject, Irp);
             break;
-            
+
         case IRP_MN_KERNEL_CALL:
             TRACE("IRP_MN_KERNEL_CALL\n");
-            
-            Status = fsctl_request(DeviceObject, Irp, IrpSp->Parameters.FileSystemControl.FsControlCode, FALSE);
+
+            Status = fsctl_request(DeviceObject, &Irp, IrpSp->Parameters.FileSystemControl.FsControlCode);
             break;
-            
+
         case IRP_MN_USER_FS_REQUEST:
             TRACE("IRP_MN_USER_FS_REQUEST\n");
-            
-            Status = fsctl_request(DeviceObject, Irp, IrpSp->Parameters.FileSystemControl.FsControlCode, TRUE);
+
+            Status = fsctl_request(DeviceObject, &Irp, IrpSp->Parameters.FileSystemControl.FsControlCode);
             break;
-            
+
         case IRP_MN_VERIFY_VOLUME:
             TRACE("IRP_MN_VERIFY_VOLUME\n");
-            
+
             Status = verify_volume(DeviceObject);
-            
+
             if (!NT_SUCCESS(Status) && Vcb->Vpb->Flags & VPB_MOUNTED) {
-                if (Vcb->open_files > 0) {
-                    Vcb->removing = TRUE;
-//                     Vcb->Vpb->Flags &= ~VPB_MOUNTED;
-                } else
-                    uninit(Vcb, FALSE);
+                ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
+                Vcb->removing = TRUE;
+                ExReleaseResourceLite(&Vcb->tree_lock);
             }
-            
+
             break;
-           
+
         default:
             break;
     }
 
-    Irp->IoStatus.Status = Status;
+end:
+    TRACE("returning %08x\n", Status);
 
-    IoCompleteRequest(Irp, IO_NO_INCREMENT);
-    
-exit:
-    if (top_level) 
+    if (Irp) {
+        Irp->IoStatus.Status = Status;
+
+        IoCompleteRequest(Irp, IO_NO_INCREMENT);
+    }
+
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
+
     FsRtlExitFileSystem();
 
     return Status;
 }
 
-static NTSTATUS STDCALL drv_lock_control(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+_Dispatch_type_(IRP_MJ_LOCK_CONTROL)
+_Function_class_(DRIVER_DISPATCH)
+static NTSTATUS drv_lock_control(_In_ PDEVICE_OBJECT DeviceObject, _In_ PIRP Irp) {
     NTSTATUS Status;
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     fcb* fcb = IrpSp->FileObject->FsContext;
@@ -4374,185 +4819,320 @@
     FsRtlEnterFileSystem();
 
     top_level = is_top_level(Irp);
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_lock_control(DeviceObject, Irp);
+
+        Irp->IoStatus.Status = Status;
+        IoCompleteRequest(Irp, IO_NO_INCREMENT);
+
         goto exit;
     }
-    
+
     TRACE("lock control\n");
-    
+
     Status = FsRtlProcessFileLock(&fcb->lock, Irp, NULL);
 
     fcb->Header.IsFastIoPossible = fast_io_possible(fcb);
-    
+
 exit:
-    if (top_level) 
+    TRACE("returning %08x\n", Status);
+
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
+
     FsRtlExitFileSystem();
-    
-    return Status;
-}
 
-NTSTATUS part0_passthrough(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
-    NTSTATUS Status;
-    part0_device_extension* p0de = DeviceObject->DeviceExtension;
-    
-    IoSkipCurrentIrpStackLocation(Irp);
-    
-    Status = IoCallDriver(p0de->devobj, Irp);
-    
     return Status;
 }
 
-static NTSTATUS STDCALL drv_shutdown(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp) {
+_Dispatch_type_(IRP_MJ_SHUTDOWN)
+_Function_class_(DRIVER_DISPATCH)
+static NTSTATUS drv_shutdown(_In_ PDEVICE_OBJECT DeviceObject, _In_ PIRP Irp) {
     NTSTATUS Status;
     BOOL top_level;
     device_extension* Vcb = DeviceObject->DeviceExtension;
 
-    TRACE("shutdown\n");
-    
     FsRtlEnterFileSystem();
 
+    TRACE("shutdown\n");
+
     top_level = is_top_level(Irp);
-    
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
-        goto exit;
-    }    
-    
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_shutdown(DeviceObject, Irp);
+        goto end;
+    }
+
     Status = STATUS_SUCCESS;
 
+    shutting_down = TRUE;
+    KeSetEvent(&mountmgr_thread_event, 0, FALSE);
+
     while (!IsListEmpty(&VcbList)) {
         Vcb = CONTAINING_RECORD(VcbList.Flink, device_extension, list_entry);
-        
+
         TRACE("shutting down Vcb %p\n", Vcb);
-        
+
         uninit(Vcb, TRUE);
     }
-    
+
+#ifdef _DEBUG
+    if (comfo) {
+        ObDereferenceObject(comfo);
+        comdo = NULL;
+        comfo = NULL;
+    }
+#endif
+
+end:
     Irp->IoStatus.Status = Status;
     Irp->IoStatus.Information = 0;
 
     IoCompleteRequest( Irp, IO_NO_INCREMENT );
 
+    if (top_level)
+        IoSetTopLevelIrp(NULL);
+
+    FsRtlExitFileSystem();
+
+    return Status;
+}
+
+_Dispatch_type_(IRP_MJ_POWER)
+_Function_class_(DRIVER_DISPATCH)
+static NTSTATUS drv_power(_In_ PDEVICE_OBJECT DeviceObject, _In_ PIRP Irp) {
+    NTSTATUS Status;
+    device_extension* Vcb = DeviceObject->DeviceExtension;
+    BOOL top_level;
+
+    FsRtlEnterFileSystem();
+
+    top_level = is_top_level(Irp);
+
+    Irp->IoStatus.Information = 0;
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_power(DeviceObject, Irp);
+
+        Irp->IoStatus.Status = Status;
+        IoCompleteRequest(Irp, IO_NO_INCREMENT);
+
+        goto exit;
+    } else if (Vcb && Vcb->type == VCB_TYPE_FS) {
+        IoSkipCurrentIrpStackLocation(Irp);
+
+        Status = IoCallDriver(Vcb->Vpb->RealDevice, Irp);
+
+        goto exit;
+    }
+
+    Status = STATUS_INVALID_DEVICE_REQUEST;
+    Irp->IoStatus.Status = Status;
+    IoCompleteRequest(Irp, IO_NO_INCREMENT);
+
 exit:
-    if (top_level) 
+    if (top_level)
         IoSetTopLevelIrp(NULL);
-    
+
     FsRtlExitFileSystem();
 
     return Status;
 }
 
-BOOL is_file_name_valid(PUNICODE_STRING us) {
+_Dispatch_type_(IRP_MJ_SYSTEM_CONTROL)
+_Function_class_(DRIVER_DISPATCH)
+static NTSTATUS drv_system_control(_In_ PDEVICE_OBJECT DeviceObject, _In_ PIRP Irp) {
+    NTSTATUS Status;
+    device_extension* Vcb = DeviceObject->DeviceExtension;
+    BOOL top_level;
+
+    FsRtlEnterFileSystem();
+
+    top_level = is_top_level(Irp);
+
+    Irp->IoStatus.Information = 0;
+
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        volume_device_extension* vde = DeviceObject->DeviceExtension;
+
+        IoSkipCurrentIrpStackLocation(Irp);
+
+        Status = IoCallDriver(vde->pdo, Irp);
+
+        goto exit;
+    } else if (Vcb && Vcb->type == VCB_TYPE_FS) {
+        IoSkipCurrentIrpStackLocation(Irp);
+
+        Status = IoCallDriver(Vcb->Vpb->RealDevice, Irp);
+
+        goto exit;
+    }
+
+    Status = Irp->IoStatus.Status;
+    IoCompleteRequest(Irp, IO_NO_INCREMENT);
+
+exit:
+    if (top_level)
+        IoSetTopLevelIrp(NULL);
+
+    FsRtlExitFileSystem();
+
+    return Status;
+}
+
+BOOL is_file_name_valid(_In_ PUNICODE_STRING us, _In_ BOOL posix) {
     ULONG i;
-    
+
     if (us->Length < sizeof(WCHAR))
         return FALSE;
-    
+
     if (us->Length > 255 * sizeof(WCHAR))
         return FALSE;
-    
+
     for (i = 0; i < us->Length / sizeof(WCHAR); i++) {
-        if (us->Buffer[i] == '/' || us->Buffer[i] == '<' || us->Buffer[i] == '>' || us->Buffer[i] == ':' || us->Buffer[i] == '"' ||
-            us->Buffer[i] == '|' || us->Buffer[i] == '?' || us->Buffer[i] == '*' || (us->Buffer[i] >= 1 && us->Buffer[i] <= 31))
+        if (us->Buffer[i] == '/' || us->Buffer[i] == 0 ||
+            (!posix && (us->Buffer[i] == '<' || us->Buffer[i] == '>' || us->Buffer[i] == ':' || us->Buffer[i] == '"' ||
+            us->Buffer[i] == '|' || us->Buffer[i] == '?' || us->Buffer[i] == '*' || (us->Buffer[i] >= 1 && us->Buffer[i] <= 31))))
             return FALSE;
     }
-    
+
     if (us->Buffer[0] == '.' && (us->Length == sizeof(WCHAR) || (us->Length == 2 * sizeof(WCHAR) && us->Buffer[1] == '.')))
         return FALSE;
-    
+
     return TRUE;
 }
 
-void chunk_lock_range(device_extension* Vcb, chunk* c, UINT64 start, UINT64 length) {
+void chunk_lock_range(_In_ device_extension* Vcb, _In_ chunk* c, _In_ UINT64 start, _In_ UINT64 length) {
     LIST_ENTRY* le;
     BOOL locked;
     range_lock* rl;
-    
+
     rl = ExAllocateFromNPagedLookasideList(&Vcb->range_lock_lookaside);
     if (!rl) {
         ERR("out of memory\n");
         return;
     }
-    
+
     rl->start = start;
     rl->length = length;
     rl->thread = PsGetCurrentThread();
-    
+
     while (TRUE) {
-        KIRQL irql;
-        
         locked = FALSE;
-        
-        KeAcquireSpinLock(&c->range_locks_spinlock, &irql);
-        
+
+        ExAcquireResourceExclusiveLite(&c->range_locks_lock, TRUE);
+
         le = c->range_locks.Flink;
         while (le != &c->range_locks) {
             range_lock* rl2 = CONTAINING_RECORD(le, range_lock, list_entry);
-            
+
             if (rl2->start < start + length && rl2->start + rl2->length > start && rl2->thread != PsGetCurrentThread()) {
                 locked = TRUE;
                 break;
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (!locked) {
             InsertTailList(&c->range_locks, &rl->list_entry);
-            
-            KeReleaseSpinLock(&c->range_locks_spinlock, irql);
+
+            ExReleaseResourceLite(&c->range_locks_lock);
             return;
         }
-        
+
         KeClearEvent(&c->range_locks_event);
-        
-        KeReleaseSpinLock(&c->range_locks_spinlock, irql);
-        
+
+        ExReleaseResourceLite(&c->range_locks_lock);
+
         KeWaitForSingleObject(&c->range_locks_event, UserRequest, KernelMode, FALSE, NULL);
     }
 }
 
-void chunk_unlock_range(device_extension* Vcb, chunk* c, UINT64 start, UINT64 length) {
-    KIRQL irql;
+void chunk_unlock_range(_In_ device_extension* Vcb, _In_ chunk* c, _In_ UINT64 start, _In_ UINT64 length) {
     LIST_ENTRY* le;
-    
-    KeAcquireSpinLock(&c->range_locks_spinlock, &irql);
-    
+
+    ExAcquireResourceExclusiveLite(&c->range_locks_lock, TRUE);
+
     le = c->range_locks.Flink;
     while (le != &c->range_locks) {
         range_lock* rl = CONTAINING_RECORD(le, range_lock, list_entry);
-        
+
         if (rl->start == start && rl->length == length) {
             RemoveEntryList(&rl->list_entry);
             ExFreeToNPagedLookasideList(&Vcb->range_lock_lookaside, rl);
             break;
         }
-        
+
         le = le->Flink;
     }
-    
+
     KeSetEvent(&c->range_locks_event, 0, FALSE);
-    
-    KeReleaseSpinLock(&c->range_locks_spinlock, irql);
+
+    ExReleaseResourceLite(&c->range_locks_lock);
 }
 
+void log_device_error(_In_ device_extension* Vcb, _Inout_ device* dev, _In_ int error) {
+    dev->stats[error]++;
+    dev->stats_changed = TRUE;
+    Vcb->stats_changed = TRUE;
+}
+
 #ifdef _DEBUG
-static void STDCALL init_serial() {
+_Function_class_(KSTART_ROUTINE)
+static void serial_thread(void* context) {
+    LARGE_INTEGER due_time;
+    KTIMER timer;
+
+    UNUSED(context);
+
+    KeInitializeTimer(&timer);
+
+    due_time.QuadPart = (UINT64)-10000000;
+
+    KeSetTimer(&timer, due_time, NULL);
+
+    while (TRUE) {
+        KeWaitForSingleObject(&timer, Executive, KernelMode, FALSE, NULL);
+
+        init_serial(FALSE);
+
+        if (comdo)
+            break;
+
+        KeSetTimer(&timer, due_time, NULL);
+    }
+
+    KeCancelTimer(&timer);
+
+    PsTerminateSystemThread(STATUS_SUCCESS);
+
+    serial_thread_handle = NULL;
+}
+
+static void init_serial(BOOL first_time) {
     NTSTATUS Status;
-    
+
     Status = IoGetDeviceObjectPointer(&log_device, FILE_WRITE_DATA, &comfo, &comdo);
     if (!NT_SUCCESS(Status)) {
         ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
+
+        if (first_time) {
+            NTSTATUS Status;
+
+            Status = PsCreateSystemThread(&serial_thread_handle, 0, NULL, NULL, NULL, serial_thread, NULL);
+            if (!NT_SUCCESS(Status)) {
+                ERR("PsCreateSystemThread returned %08x\n", Status);
+                return;
+            }
+        }
     }
 }
 #endif
 
 #ifndef __REACTOS__
-static void STDCALL check_cpu() {
+static void check_cpu() {
     unsigned int cpuInfo[4];
 #ifndef _MSC_VER
     __get_cpuid(1, &cpuInfo[0], &cpuInfo[1], &cpuInfo[2], &cpuInfo[3]);
@@ -4568,7 +5148,7 @@
         TRACE("SSE4.2 is supported\n");
     else
         TRACE("SSE4.2 not supported\n");
-    
+
     if (have_sse2)
         TRACE("SSE2 is supported\n");
     else
@@ -4578,8 +5158,10 @@
 
 #ifdef _DEBUG
 static void init_logging() {
+    ExAcquireResourceExclusiveLite(&log_lock, TRUE);
+
     if (log_device.Length > 0)
-        init_serial();
+        init_serial(TRUE);
     else if (log_file.Length > 0) {
         NTSTATUS Status;
         OBJECT_ATTRIBUTES oa;
